<?php

namespace App\Services\Traits\Msds;

use App\Services\Traits\BaseService;

trait MsdsTrait
{
    use BaseService;

    public function getCnMsds($msds_html, $params)
    {
        if(!empty($params)){
            $msds_html = preg_replace('/<dt>企业名称：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>企业名称：</dt> <dd>'.$params['company_name'].'</dd>', $msds_html);
            $msds_html = preg_replace('/<dt>企业地址：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>企业地址：</dt> <dd>'.$params['company_address'].'</dd>', $msds_html);
            $msds_html = preg_replace('/<dt>传真：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>传真：</dt> <dd>'.$params['company_fax'].'</dd>', $msds_html);
            $msds_html = preg_replace('/<dt>联系电话：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>联系电话：</dt> <dd>'.$params['company_phone'].'</dd>', $msds_html);
            $msds_html = preg_replace('/<dt>企业应急电话：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>企业应急电话：</dt> <dd>'.$params['company_urgency_phone'].'</dd>', $msds_html);
        }

        preg_match('/<body>[\s]*?<style>(?<bodyStyle>[\s\S]*?)<\/style>/i',$msds_html, $bodyStyle);
        $bodyStyle['bodyStyle'] = "<style>body{  font-family: 'msyh'; font-size: 0.8rem; font-weight: normal; display: block;} h2{font-size: 2.0rem; text-align: center;}.container { padding-right: 5px;padding-left: 5px;margin-right: auto;margin-left: auto;width: 100%;} .sds-cn dd p { font-weight: normal; margin-left: 20px; }" .
            $bodyStyle['bodyStyle']."</style><body>";

        // 格式化处理
        $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?\{[\s]*?line-height: 1.5;[\s]*?\}/i', '.sds-cn{line-height: 2.5;}', $bodyStyle['bodyStyle']);
        $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?\.b-a[\s]*?\{[\s]*?border: 1px solid #000000;[\s]*?\}/i', '.sds-cn .b-a { border: 1px solid #000000; margin-left:10px;}', $bodyStyle['bodyStyle']);
        $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?dd.clearfix[\s]*?\{ margin-left: 20px;[\s]*?\}/i', '.sds-cn dd.clearfix { width:80% }', $bodyStyle['bodyStyle']);
        $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?dt[\s]*?\{[\s]*?float: left; font-weight: bold; clear: left; [\s]*?\}/i', '.sds-cn dt { float: left; font-weight: normal; clear: left; }', $bodyStyle['bodyStyle']);
        $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?\.list-line[\s]*?li:before[\s]*?\{ content: " —— " \}/i', '.sds-cn .list-line li:before { content: " -- " }', $bodyStyle['bodyStyle']);
        $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?p[\s]*?\{[\s]*?margin:[\s]*?0; \}/i', '.sds-cn p { margin: 0 15px;word-wrap:break-word; }', $bodyStyle['bodyStyle']);


        $msds_html = preg_replace('/<html>/i', '<html lang="zh_CN no-js">', $msds_html);
        //$msds_html = preg_replace('/<meta[\s]*?charset=[\"]UTF\-8[\"]/i', '<meta http-equiv="Content-Type" content="text/html; charset=utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=no">', $msds_html);

        $msds_html = preg_replace('/<body><style>(?<bodyStyle>[\s\S]*?)<\/style>/i', '@body@', $msds_html);
        $msds_html = preg_replace('/<\/body>/', '</body>', preg_replace('/@body@/', $bodyStyle['bodyStyle'], $msds_html));
        //$msds_html = preg_replace('/@body@/', $newMsdsHtml, $msds_html);

        if(preg_match('/<div[\s]*?class=[\\\'|\"]sds-cn[\\\'|\"]>/i', $msds_html)){
            $msds_html = str_replace('<div class="sds-cn">','<div class="sds-cn"><h2 style="height:100px"><img src="'.$params['company_logo'].'" style="text-align:center;height:90px;"></h2>', $msds_html);
        }

        if(preg_match('/<div[\s]*?class=[\\\'|\"]sds-cn-header[\\\'|\"]>(?<content>[\s\S]+?)<\/div>/i', $msds_html, $content)){
            $msds_html = str_replace('化学品安全技术说明书 ', '<h2 style="font-size: 1.5rem;font-weight: bold">化学品安全技术说明书 </h2>', $msds_html);
        }

        if(preg_match('/<div[\s]*?class=[\\\'|\"]sds-cn-content[\\\'|\"]>(?<content>[\s\S]+?)<\/div><\/body>/i', $msds_html, $content)){
            if($content['content']){
                preg_match_all('/(?<title>[\s\S]*?)<dl>(?<dlContent>[\s\S]*?)<\/dl>/i', $content['content'], $dlContent);
                if($dlContent['dlContent']){
                    $newMsdsHtml = '';
                    foreach($dlContent['dlContent'] as $key => $dl){
                        $msds_html = str_replace($dlContent['title'][$key],'<h2 style="font-size: 1.3rem;font-weight: bold">'.$dlContent['title'][$key].'</h2>', $msds_html);
                        if(in_array($key, [0,5,9])){
                            $dlHtml = '';
                            if($dlContent['title'][$key]){
                                //$dlHtml = '<h2 style="font-size: 20px; text-align: center;" align="center">'.$dlContent['title'][$key].'</h2>';
                                preg_match_all('/<dt>(?<cTitle>[\s\S]*?)<\/dt>[\s]*?<dd[\s\S]*?>(?<cContent>[\s\S]*?)<\/dd>/i', $dl, $ddContent);
                                if($ddContent){
                                    foreach($ddContent['cTitle'] as $k => $c){
                                        $dlHtml .= '<div><span style="margin: 0;"><b>'.$c.'</b></span>';
                                        $dlHtml .= '<span style="font-weight: normal">'.$ddContent['cContent'][$k].'</span></div>';
                                    }
                                }
                            }
                            $msds_html = str_replace($dl, $dlHtml, $msds_html);
                        }
                        if(in_array($key, [1,2,3,4,6,7,8,10,11,12])){
                            preg_match_all('/<dt>(?<cTitle>[\s\S]*?)<\/dt>[\s]*?<dd[\s\S]*?>(?<cContent>[\s\S]*?)<\/dd>/i', $dl, $ddContent);
                            if($ddContent){
                                $dlHtml = '';
                                foreach($ddContent['cTitle'] as $k => $c){
                                    $dlHtml .= '<div style="width:90%"><span style="margin: 0;"><b>'.$c.'</b></span>';
                                    $dlHtml .= '<span style="font-weight: normal;">'.$ddContent['cContent'][$k].'</span></div>';
                                }
                            }
                            $msds_html = str_replace($dl, $dlHtml, $msds_html);
                        }
                        if($key == 13){
                            preg_match_all('/<dt>(?<cTitle>[\s\S]*?)<\/dt>[\s]*?<dd[\s\S]*?>(?<cContent>[\s\S]*?)<\/dd>/i', $dl, $ddContent);
                            if($ddContent){
                                $dlHtml = '';
                                foreach($ddContent['cTitle'] as $k => $c){
                                    if($k == (count($ddContent['cTitle']) - 1)){
                                        $dlHtml .= '<div style="width:90%"><span style="margin: 0;"><b>'.$c.'</b></span>';
                                        $dlHtml .= '<span style="font-weight: normal;"><p>'.$ddContent['cContent'][$k].'</p></span></div>';
                                    }else{
                                        $dlHtml .= '<div style="width:90%"><span style="margin: 0;"><b>'.$c.'</b></span>';
                                        $dlHtml .= '<span style="font-weight: normal;">'.$ddContent['cContent'][$k].'</span></div>';
                                    }
                                }
                            }
                            $msds_html = str_replace($dl, $dlHtml, $msds_html);
                        }
                    }
                }
                if(preg_match('/<h2[\s]*?style=[\\\'|\"]font-size: 1.3rem;font-weight: bold[\\\'|\"]>[\s]*?(?<cTitle>第9部分 理化特性)(?<content>[\s\S]*?)<\/h2>/i', $msds_html,$content)){
                    if($content['content']){
                        $msds_html = str_replace($content['cTitle'], $content['cTitle'].'</h2>', $msds_html);
                        $tableInfo = str_replace('第10部分 稳定性和反应性', '', $content['content']);
                        $tableInfo .= '<h2 style="font-size: 1.3rem;font-weight: bold">第10部分 稳定性和反应性</h2>';

                        $msds_html = str_replace($content['content'], $tableInfo, $msds_html);
                    }
                }
                if(preg_match('/<h2[\s]*?style=[\\\'|\"]font-size: 1.3rem;font-weight: bold[\\\'|\"]>[\s]*?第15部分 法规信息(?<content>[\s\S]*?)<\/h2>/i', $msds_html,$content)){
                    if($content['content']){
                        $dlHtml = '';
                        preg_match('/<p>(?<cTitle>[\s\S]*?)<\/p>[\s]*?<u>(?<cContent>[\s\S]*?)<\/u>/i', $content['content'], $c);
                        $dlHtml .= '<div style="width:90%"><span style="margin: 0;"><b>'.$c['cTitle'].'</b></span>';
                        $dlHtml .= '<span style="font-weight: normal;"><p>'.$c['cContent'].'</p></span></div>';

                        $msds_html = str_replace($content['content'], '</h2>'.str_replace('</h2>', '',$content['content']), $msds_html);
                        $msds_html = str_replace($content['content'], $dlHtml, $msds_html);
                    }
                }
                /*preg_match('/(?<title>第[\s]*?3[\s\S]+?)<table[\s]*?class=[\\\'|\"]table-text-center avoid-page-break-inside[\\\'|\"]>[\s\S]*?<\/table>/i', $content['content'], $tableContent);
                if($tableContent['title']){
                    $msds_html = str_replace($tableContent['title'],'<h2 style="font-size: 1.3rem;font-weight: bold">'.$tableContent['title'].'</h2>', $msds_html);
                }

                preg_match('/(?<title>第4[\s\S]*?)<dl>[\s\S]*?<\/dl>/i', $content['content'], $dlContent);
                if($dlContent['title']){
                    $msds_html = str_replace($dlContent['title'],'<h2 style="font-size: 1.3rem;font-weight: bold">'.$dlContent['title'].'</h2>', $msds_html);
                }*/
            }
        }

        return $msds_html;
    }

    public function getEnMsds($msds_html, $params)
    {
        if(!empty($params)) {
            $msds_html = preg_replace('/<th[\s]*?class=[\\\'|\"]width-pc-30[\\\'|\"]>Company<\/th>[\s\S]*?<td[\s]*?class=[\\\'|\"]width-pc-70[\\\'|\"]>[\s\S]*?<\/td>/i', '<th class="width-pc-30">Company：</th> <td class="width-pc-70">' . $params['company_name'] . '</td>', $msds_html);
            $msds_html = preg_replace('/<th[\s]*?class=[\\\'|\"]width-pc-30[\\\'|\"]>Address<\/th>[\s\S]*?<td[\s]*?class=[\\\'|\"]width-pc-70[\\\'|\"]>[\s\S]*?<\/td>/i', '<th class="width-pc-30">Address：</dt> <td>' . $params['company_address'] . '</td>', $msds_html);
            $msds_html = preg_replace('/<th[\s]*?class=[\\\'|\"]width-pc-30[\\\'|\"]>Fax<\/th>[\s\S]*?<td[\s]*?class=[\\\'|\"]width-pc-70[\\\'|\"]>[\s\S]*?<\/td>/i', '<th class="width-pc-30">Fax：</dt> <td>' . $params['company_fax'] . '</td>', $msds_html);
            $msds_html = preg_replace('/<th[\s]*?class=[\\\'|\"]width-pc-30[\\\'|\"]>Telephone<\/th>[\s\S]*?<td[\s]*?class=[\\\'|\"]width-pc-70[\\\'|\"]>[\s\S]*?<\/td>/i', '<th class="width-pc-30">Telephone：</dt> <td>' . $params['company_phone'] . '</td>', $msds_html);
        }


        $msds_html = str_replace("font-family: 'times_new_roman', 'Times New Roman', sans-serif", "font-family: 'msyh'", $msds_html);
        $msds_html = preg_replace('/<html>/i', '<html lang="zh_CN no-js">', $msds_html);
        //$msds_html = preg_replace('/<meta[\s]*?charset=[\"]UTF\-8[\"]/i', '<meta http-equiv="Content-Type" content="text/html; charset=utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=no">', $msds_html);

        if(preg_match('/<div[\s]*?class=[\\\'|\"]sds-ghs[\\\'|\"]>/i', $msds_html)){
            $msds_html = str_replace('<div class="sds-ghs">','<div class="sds-ghs"><h2 style="height:100px;margin: 1.83em 0"><img src="'.$params['company_logo'].'" style="text-align:center;height:90px;"></h2>', $msds_html);
        }

        return $msds_html;
    }

}
