<?php

$api->version('v1', function($api) {

    //获取token
    $api->group(['namespace'=>'App\Http\Controllers\V1\Auth\Chemsite','middleware' => ['maintenance','throttle:60,1']], function($api) {
        $api->post('/openapi/auth/chemsite/getToken', ['uses'=>'CompanyAuthController@getToken']);
    });

    $api->group(['namespace'=>'App\Http\Controllers\V1\Chemsite','middleware' => ['maintenance','throttle:60,1','apiAuth','requestlogs'], 'providers' => 'jwt'], function($api) {
        // 新建订单
        $api->post('/openapi/chemsite/orders/createOrders', ['permission' => 'chemsite.createOrders', 'uses'=>'OrdersController@createCustomerNewOrder']);
    });

    $api->group(['namespace'=>'App\Http\Controllers\V1\Chemicals','middleware' => ['maintenance','throttle:60,1','apiAuth','requestlogs'], 'providers' => 'jwt'], function($api) {
        // 新建订单
        $api->post('/openapi/chemicals/msds/get', ['permission' => 'chemicals.getMsds', 'uses'=>'MsdsController@getMsds']);
    });

    $api->group(['namespace'=>'App\Http\Controllers\V1\Chemicals','middleware' => ['throttle:60,1']], function($api) {
        $api->get('/storage/download/{path}', ['uses'=>'MsdsController@downloadFile']);
        $api->get('/storage/pdf/{path}', ['uses'=>'MsdsController@viewPdf']);
    });

    $api->group(['namespace'=>'App\Http\Controllers\V1\Auth','middleware' => ['maintenance','throttle:60,1']], function($api) {
        $api->post('/openapi/auth/msds/getToken', ['uses'=>'CustomerAuthController@getToken']);
    });

});

